xref: /freebsd/tools/boot/ci-qemu-test.sh (revision b6539d47bd5ba582e687be42930745d62c20f55b)
1#!/bin/sh
2
3# Install loader, kernel, and enough of userland to boot in QEMU and echo
4# "Hello world." from init, as a very quick smoke test for CI.  Uses QEMU's
5# virtual FAT filesystem to avoid the need to create a disk image.  While
6# designed for CI automated testing, this script can also be run by hand as
7# a quick smoke-test.  The rootgen.sh and related scripts generate much more
8# extensive tests for many combinations of boot env (ufs, zfs, geli, etc).
9#
10# $FreeBSD$
11
12set -e
13
14die()
15{
16	echo "$*" 1>&2
17	exit 1
18}
19
20tempdir_cleanup()
21{
22	trap - EXIT SIGINT SIGHUP SIGTERM SIGQUIT
23	rm -rf ${ROOTDIR}
24}
25
26tempdir_setup()
27{
28	# Create minimal directory structure and populate it.
29	# Caller must cd ${SRCTOP} before calling this function.
30
31	for dir in dev bin efi/boot etc lib libexec sbin usr/lib usr/libexec; do
32		mkdir -p ${ROOTDIR}/${dir}
33	done
34
35	# Install kernel, loader and minimal userland.
36
37	make -DNO_ROOT DESTDIR=${ROOTDIR} \
38	    MODULES_OVERRIDE= \
39	    WITHOUT_DEBUG_FILES=yes \
40	    WITHOUT_KERNEL_SYMBOLS=yes \
41	    installkernel
42	for dir in stand \
43	    lib/libc lib/libedit lib/ncurses \
44	    libexec/rtld-elf \
45	    bin/sh sbin/init sbin/shutdown; do
46		make -DNO_ROOT DESTDIR=${ROOTDIR} INSTALL="install -U" \
47		    WITHOUT_DEBUG_FILES= \
48		    WITHOUT_MAN= \
49		    WITHOUT_PROFILE= \
50		    WITHOUT_TESTS= \
51		    WITHOUT_TOOLCHAIN= \
52		    -C ${dir} install
53	done
54
55	# Put loader in standard EFI location.
56	mv ${ROOTDIR}/boot/loader.efi ${ROOTDIR}/efi/boot/BOOTx64.EFI
57
58	# Configuration files.
59	cat > ${ROOTDIR}/boot/loader.conf <<EOF
60vfs.root.mountfrom="msdosfs:/dev/ada0s1"
61autoboot_delay=-1
62boot_verbose=YES
63EOF
64	cat > ${ROOTDIR}/etc/rc <<EOF
65#!/bin/sh
66
67echo "Hello world."
68/sbin/shutdown -p now
69EOF
70
71	# Remove unnecessary files to keep FAT filesystem size down.
72	rm -rf ${ROOTDIR}/METALOG ${ROOTDIR}/usr/lib
73}
74
75# Locate the top of the source tree, to run make install from.
76: ${SRCTOP:=$(make -V SRCTOP)}
77if [ -z "${SRCTOP}" ]; then
78	die "Cannot locate top of source tree"
79fi
80
81# Locate the uefi bios file used by qemu.
82: ${OVMF:=/usr/local/share/UEFI-firmware/QEMU_UEFI_CODE_x86_64.fd}
83if [ ! -r "${OVMF}" ]; then
84	die "Cannot read UEFI bios file ${OVMF}"
85fi
86
87# Create a temp dir to hold the boot image.
88ROOTDIR=$(mktemp -d -t ci-qemu-test-fat-root)
89trap tempdir_cleanup EXIT SIGINT SIGHUP SIGTERM SIGQUIT
90
91# Populate the boot image in a temp dir.
92( cd ${SRCTOP} && tempdir_setup )
93
94# And, boot in QEMU.
95: ${BOOTLOG:=${TMPDIR}/ci-qemu-test-boot.log}
96timeout 300 \
97    qemu-system-x86_64 -m 256M -bios ${OVMF} \
98        -serial stdio -vga none -nographic -monitor none \
99        -snapshot -hda fat:${ROOTDIR} 2>&1 | tee ${BOOTLOG}
100
101# Check whether we succesfully booted...
102if grep -q 'Hello world.' ${BOOTLOG}; then
103	echo "OK"
104else
105	die "Did not boot successfully, see ${BOOTLOG}"
106fi
107